const ProgressBarPlugin = require('progress-bar-webpack-plugin');
const chalk = require('chalk');

const merge = require('webpack-merge');
const common = require('./webpack.common.config');

module.exports = function(indexJSPath, nodeModulesPath, host){
    common.entry = indexJSPath;
    common.resolve.modules = [nodeModulesPath];
    return merge(common, {
        devtool: 'cheap-eval-source-map',

        devServer: {
            proxy: {
                '/': {
                    target: `https://${host}`,
                    secure: false,
                    autoRewrite: true,
                    xfwd: true,
                }
            }
        },

        plugins: [
            new ProgressBarPlugin({
                format: '  build [:bar] ' + chalk.green.bold(':percent') +
                ' (:elapsed seconds)',
                clear: false,
            })
        ]
    })
};
