const WebpackDevServer = require("webpack-dev-server");
const webpack = require("webpack");
const webpackDevConfigCreator = require('../config/webpack.dev.config');
const webpackDevServerConfigCreator = require('../config/webpackDevServer.config');
const colors = require('../config/colors');

module.exports = function index(indexJSPath, nodeModulesPath, host, proxyPort, config) {
    const webpackDevConfig = webpackDevConfigCreator(indexJSPath, nodeModulesPath, host);
    const compiler = webpack(webpackDevConfig);
    const webpackDevServerConfig = webpackDevServerConfigCreator(config);
    const server = new WebpackDevServer(compiler, webpackDevServerConfig);

    server.listen(proxyPort, "localhost", function() {
        console.log('Listening on https://localhost:' + proxyPort);
    }).on('error', (err) => {
        console.error(`${colors.FgRed}ERROR: Couldn't start proxy on port ${proxyPort}.
        Is it already running?
        ${err}
        ${colors.Reset}`);
    });
};
